<?php

class Template{
/*

A simple class Template by Felix021

用法:
$t = new Template("template.php");
$name = "title";
$value = "test1";
$variablename = "t_header";
$t->setvar($name, $value, $variablename);
$t->printvar($variablename [, true]);//后面的可选，若填上true则代表经过html编码后输出

name另: 和value可以是简单的字符串，也可以是一个一维字符串数组，但要可以用数字进行遍历. 如
$name = array("a", "b", "c");
$value = array("1", "2", "3");
$t->setvar($name, $value, $t_test);

可以重复使用.

*/
var $filename; //模板文件名
var $orig;  //读取出来的变量
var $vars;  //替换后的变量, 若未替换则和$orig相同

var $valid; //操作是否有效
var $errmsg; //错误信息

function __construct($filename = ""){
    if(!file_exists($filename)){
        $this->valid = false;
        $this->errmsg = "Error in __construct: Please supply valid filename.";
    }else{
        $this->filename = $filename;
        include($filename);
        $this->orig = get_defined_vars();
        $this->vars = $this->orig;
        $this->valid = true;
    }
}//end of function __construct()

function setvar($name, $value, $variable = ""){
    if($variable !== ""){ //只替换某个变量
        if(!isset($this->orig[$variable])){
            $this->valid = false;
            $this->errmsg = "Error in setvar: Please supply a valid variable name";
            return false;
        }else{
            if(!is_array($name)){ //简单替换
                $this->vars[$variable] = str_replace("{" . $name . "}", $value, $this->orig[$variable]);
                $this->valid = true;
                return true;
            }else{//如果用数组方式替换
                $n = count($name);
                $this->vars[$variable] = $this->orig[$variable];
                for($i = 0; $i < $n; $i++){
                    $this->vars[$variable] = str_replace("{".$name[$i]."}", $value[$i], $this->vars[$variable]);
                }
                $this->valid = true;
                return true;
            }
        }
    }else{ //替换所有变量
        $this->vars = $this->orig;
        if(!is_array($name)){ //简单替换
            foreach($this->vars as &$var){
                $var = str_replace("{" . $name . "}", $value, $var);
            }
            $this->valid = true;
            return true;
        }else{//如果用数组方式替换
            $n = count($name);
            foreach($this->vars as &$var){
                for($i = 0; $i < $n; $i++){
                    $var = str_replace("{".$name[$i]."}", $value[$i], $var);
                }
            }
            $this->valid = true;
            return true;
        }
    }
}//end of function setvar()

function printvar($variable, $htmlspecialchar_encode = false){
    if(!isset($this->vars[$variable])){
        $this->valid = false;
        $this->errmsg = "Error in setvar: Please supply a valid variable name";
        return false;
    }else{
        if($htmlspecialchar_encode){
            echo htmlspecialchars($this->vars[$variable]);
        }else{
            echo $this->vars[$variable];
        }
    }
}//end of function printvar()

}; //end of class Template
?>
